# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define stax2_version 3.1.1

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%define repodir %{_javadir}/repository.jboss.com/woodstox/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define oname woodstox
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           wstx4
Version:        4.1.2
Release:	2%{?dist}
Epoch:          0
Summary:        Woodstox Stax Implementation
License:        ASL 2.0
Group:          Development/Libraries/Java
URL:            http://woodstox.codehaus.org/
Source0:        woodstox-4.1.2.tgz
# svn export http://svn.codehaus.org/woodstox/wstx/tags/4.1.2/ woodstox-4.1.2
# tar czf woodstox-4.1.2.tgz woodstox-4.1.2/

Source1:        http://repository.codehaus.org/org/codehaus/woodstox/woodstox-core-asl/4.1.2/woodstox-core-asl-4.1.2.pom
Source2:        http://repository.codehaus.org/org/codehaus/woodstox/woodstox-core-lgpl/4.1.2/woodstox-core-lgpl-4.1.2.pom
Source3:        wstx4-component-info.xml
Source4:        http://repository.codehaus.org/org/codehaus/woodstox/stax2-api/3.1.1/stax2-api-3.1.1.pom
Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5
Requires:       jpackage-utils >= 0:1.7.5
Requires:       java >= 0:1.6.0
Requires:       jvnet-msv
Requires:       org.osgi.core
Requires:       relaxngDatatype
Requires:       stax_1_0_api
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  ant-nodeps
BuildRequires:  ant-apache-bcel
BuildRequires:  ant-junit
BuildRequires:  ant-trax
BuildRequires:  bndtask
BuildRequires:  org.osgi.core
BuildRequires:  stax_1_0_api
BuildRequires:  relaxngDatatype
BuildRequires:  emma
BuildRequires:  jvnet-msv
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:      noarch

%description
Woodstox is a high-performance validating namespace-aware 
StAX-compliant (JSR-173) Open Source XML-processor written 
in Java.

XML processor means that it handles both input (== parsing) 
and output (== writing, serialization)), as well as 
supporting tasks such as validation.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description javadoc
%{summary}.

%package manual
Group:          Development/Documentation
Summary:        Documents for %{name}

%description manual
%{summary}.

%prep
%setup -q -n %{oname}-%{version}
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
sed -i 's|<import file="build-maven-deploy.xml" />||g' build.xml

pushd release-notes
mv CREDITS{,.orig}
mv VERSION{,.orig}
%{_bindir}/iconv -f iso-8859-1 -t utf8 -o CREDITS CREDITS.orig
%{_bindir}/iconv -f iso-8859-1 -t utf8 -o VERSION VERSION.orig
rm CREDITS.orig
rm VERSION.orig
popd

pushd lib
ln -s $(build-classpath emma) .
ln -s $(build-classpath emma_ant) .
ln -s $(build-classpath stax_1_0_api) stax-api-1.0.1.jar
pushd msv
ln -s $(build-classpath jvnet-msv/msv-core) msv-core.jar
ln -s $(build-classpath jvnet-msv/xsdlib) xsdlib.jar
ln -s $(build-classpath relaxngDatatype) .
popd
pushd ant
ln -s $(build-classpath bndtask) bndtask-0.2.0.jar
popd
pushd cobertura
ln -s $(build-classpath jakarta-oro) jakarta-oro-2.0.8.jar
ln -s $(build-classpath asm2/asm2) asm-2.2.1.jar
ln -s $(build-classpath asm2/asm2-tree) asm-tree-2.2.1.jar
ln -s $(build-classpath log4j) log4j-1.2.13.jar
ln -s $(build-classpath cobertura) cobertura-1.9.jar
popd
pushd test
ln -s $(build-classpath junit) junit-3.8.1.jar
popd
pushd osgi
ln -s $(build-classpath org.osgi.core) org.osgi.core-1.2.0.jar
popd
popd

#BUILD/woodstox-4.1.2/lib/ant/maven-ant-tasks-2.0.9.jar.no

%build
export CLASSPATH=
export OPT_JAR_LIST="`%{__cat} %{_sysconfdir}/ant.d/{nodeps,apache-bcel,junit,trax}`"
%{ant} jars.osgi javadoc test 

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}/%{name}
install -p -m 644 build/stax2-api-%{stax2_version}.jar %{buildroot}%{_javadir}/%{name}/stax2-api-%{stax2_version}.jar
install -p -m 644 build/%{oname}-core-asl-%{version}.jar %{buildroot}%{_javadir}/%{name}/woodstox-core-asl-%{version}.jar
install -p -m 644 build/%{oname}-core-lgpl-%{version}.jar %{buildroot}%{_javadir}/%{name}/woodstox-core-lgpl-%{version}.jar
# create unversioned symlinks
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{version}*; do ln -s ${jar} ${jar/-%{version}/}; done)
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{stax2_version}*; do ln -s ${jar} ${jar/-%{stax2_version}/}; done)

%add_to_maven_depmap org.codehaus.woodstox stax2-api %{stax2_version} JPP/%{name} stax2-api
%add_to_maven_depmap org.codehaus.woodstox woodstox-core-asl %{version} JPP/%{name} woodstox-core-asl
%add_to_maven_depmap org.codehaus.woodstox woodstox-core-lgpl %{version} JPP/%{name} woodstox-core-lgpl

# poms
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
install -m 644 %{SOURCE1} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-wstx-asl.pom
install -m 644 %{SOURCE2} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-wstx-lgpl.pom
install -m 644 %{SOURCE4} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-stax2-api.pom

# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr build/javadoc/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

# manual
install -d -m 755 %{buildroot}%{_docdir}/%{name}-%{version}
cp -pr release-notes/* %{buildroot}%{_docdir}/%{name}-%{version}

%if %with repolib
install -d -m 0755 %{buildroot}%{repodir}
install -d -m 0755 %{buildroot}%{repodirlib}
install -p -m 0644 %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
sed -i "s/@VERSION@/%{version}-brew/g" %{buildroot}%{repodir}/component-info.xml
install -d -m 0755 %{buildroot}%{repodirsrc}
install -p -m 0644 %{SOURCE0} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_javadir}/%{name}/wstx-lgpl.jar %{buildroot}%{repodirlib}/wstx.jar
%endif

%post
%update_maven_depmap

%postun
%update_maven_depmap

%clean
rm -rf %{buildroot}

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/stax2-api*.jar
%{_javadir}/%{name}/woodstox-core-asl*.jar
%{_javadir}/%{name}/woodstox-core-lgpl*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Tue Feb 05 2013 Ralph Apel <r.apel@r-apel.de> 0:4.1.2-2
- Prevent xzpayload problem

* Fri Jan 11 2012 Ralph Apel <r.apel@r-apel.de> 0:4.1.2-1
- 4.1.2 as wstx4

* Wed Oct 06 2010 David Walluck <dwalluck@redhat.com> 0:3.2.8-3
- fix maven2 POM and depmap
- fix maven2 support
- fix jar names
- fix repolib option

* Sat Jan 09 2010 Will Tatam <will.tatam@red61.com> 3.2.8-2
- Auto rebuild for JPackage 6 in centos5 mock

* Mon Aug 11 2009 Yong Yang <yyang@redhat.com> 0:3.2.8-1
- 3.2.8

* Mon Jan 12 2009 David Walluck <dwalluck@redhat.com> 0:3.2.6-2
- use install -p
- fix repolib

* Fri Jan 09 2009 David Walluck <dwalluck@redhat.com> 0:3.2.6-1
- 3.2.6

* Tue Jul 29 2008 David Walluck <dwalluck@redhat.com> 0:3.1.1-3
- fix maven frag attributes
- fix repolib permissions

* Wed May 28 2008 David Walluck <dwalluck@redhat.com> 0:3.1.1-2.jpp5
- own %%{_javadir}/%%{name}
- merge in maven2 changes from 3.2.1-1jpp
- fix License
- fix javadoc location
- BuildRequires: ant-trax

* Tue Mar 13 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:3.1.1-1jpp.ep1.2
- Fix repolib location

* Tue Mar 13 2007 Fernando Nasser <fnasser@redhat.com> 0:3.1.1-1jpp.ep1.1
- Rebuild

* Mon Feb 26 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:3.1.1-1jpp.el4ep1.2
- Add -brew suffix

* Mon Feb 26 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:3.1.1-1jpp.el4ep1.1
- First build for EP branch
- Add repolib support

* Mon Feb 26 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:3.1.1-1jpp
- Upgrade to 3.1.1
- Fix javadoc handling to remove ghost + linking magic

* Fri May 05 2006 Ralph Apel <r.apel@r-apel.de> 0:2.9.3-1jpp
- First build
